<template>
  <div class="p-2">
    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="21">
            <span>标签类别信息列表</span>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['customer:enterpriseScale:remove']"
              >批量删除</el-button
            >
          </el-col>
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['customer:enterpriseScale:add']">新增</el-button>
          </el-col>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="enterpriseScaleList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="企业规模" align="center" prop="enterpriseScaleName" />
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['customer:enterpriseScale:edit']"
              >编辑</el-button
            >
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['customer:enterpriseScale:remove']"
              >删除</el-button
            >
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改企业规模对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="enterpriseScaleFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="企业规模" prop="enterpriseScaleName">
          <el-input v-model="form.enterpriseScaleName" placeholder="请输入企业规模" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="EnterpriseScale" lang="ts">
import {
  listEnterpriseScale,
  getEnterpriseScale,
  delEnterpriseScale,
  addEnterpriseScale,
  updateEnterpriseScale
} from '@/api/customer/customerCategory/enterpriseScale';
import { EnterpriseScaleVO, EnterpriseScaleQuery, EnterpriseScaleForm } from '@/api/customer/customerCategory/enterpriseScale/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const enterpriseScaleList = ref<EnterpriseScaleVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const enterpriseScaleFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: EnterpriseScaleForm = {
  id: undefined,
  enterpriseScaleName: undefined,
  status: undefined,
  remark: undefined,
  platformCode: undefined
};
const data = reactive<PageData<EnterpriseScaleForm, EnterpriseScaleQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    enterpriseScaleName: undefined,
    status: undefined,
    platformCode: undefined,
    params: {}
  },
  rules: {
    enterpriseScaleName: [{ required: true, message: '企业规模不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询企业规模列表 */
const getList = async () => {
  loading.value = true;
  const res = await listEnterpriseScale(queryParams.value);
  enterpriseScaleList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  enterpriseScaleFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: EnterpriseScaleVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加企业规模';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: EnterpriseScaleVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getEnterpriseScale(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改企业规模';
};

/** 提交按钮 */
const submitForm = () => {
  enterpriseScaleFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateEnterpriseScale(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addEnterpriseScale(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: EnterpriseScaleVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除企业规模编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delEnterpriseScale(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'customer/enterpriseScale/export',
    {
      ...queryParams.value
    },
    `enterpriseScale_${new Date().getTime()}.xlsx`
  );
};

onMounted(() => {
  getList();
});
</script>
